#pragma rtGlobals=1		// Use modern global access method.



//////////////////// MAKE GLOBALS ///////////////////////////////

Function MakeImageAnalysisGlobals()

	String dfSav = GetDataFolder(1)

	If(DataFolderExists("root:Globals:imaging:ImageAnalysisGlobals"))
		return 0
	Else
		NewDataFolder/O/S root:Globals:imaging:ImageAnalysisGlobals
		Make/O/N=1000 contrast_lookup; SetScale/I x,0,1, contrast_lookup
		Make/O/N=(512,512) FrameToShow
		Variable/G FrameViewerSpeed
		Variable/G gRadioVal
		Variable/G gRadioVal_range
		String/G showInViewer="*"
		String/G ImagesFolder =""
		String/G ImageStem=""
		String/G zapString
		String/G ColorTable
		String/G MovieOnDisplay
		String/G WorkingFolder
		Variable/G frameNumOfDisplayed
		Variable/G nzmax
		Variable/G nzmin
		Variable/G gamma_val=1
	EndIf
	
	SetDataFolder dfSav
End


Function QuickCalc(inwave)
	Wave inwave
	Variable index

	make/o/n=(dimsize(inwave,2)) ootwave

	Do

		ImageStats/P=(index) inwave
		ootwave[index]=V_avg
		index+=1
	While(index<dimsize(inwave,2))

End



////////////////// THis needs to write  to a folder /////////////////////
Function PlaceImageProfileLine(GraphName)
	String GraphName
	Variable index

	Variable leftMost,rightMost,topMost,BottomMost
	Variable XCoord,YCoord_top,YCoord_bottom
	
	String ImagesGraphed=ImageNameList(GraphName,";")
	
	
	If (ItemsInList(ImagesGraphed,";")!=1)
		return 0
	EndIf
	
	String WorkingAxes=AxisList(GraphName)
			
	Do
		String thisAxis =StringFromList(index,WorkingAxes,";")
			
		If (strlen(thisAxis)==0)
			break
		EndIf
			
			
		StrSwitch (thisAxis)
			
			case "top":
				
				GetAxis/Q/W=$GraphName top
				XCoord=round(V_min+(V_Max-V_min)/2)
				
				break
			
			case "bottom":
				GetAxis/Q/W=$GraphName bottom
				XCoord=round(V_min+(V_Max-V_min)/2)
				
				break
			
			case "left":
				
				GetAxis/Q/W=$GraphName left
				YCoord_top=ceil(V_min+(V_Max-V_min)*.1)
				YCoord_bottom=floor(V_max-(V_Max-V_min)*.1)
				
				break
			
			case "right":
				
				GetAxis/Q/W=$GraphName right
				YCoord_top=ceil(V_min+(V_Max-V_min)*.1)
				YCoord_bottom=floor(V_max-(V_Max-V_min)*.1)
				
				break
			
			default:
				break
			
		EndSwitch
				
		index+=1
		
	While(1)
		
	Print  num2str(XCoord)
		
	Make/O/N=2 X_coords={XCoord,XCoord}
	Make/O/N=2 Y_coords={YCoord_top,YCoord_bottom}
		
	String axNames= StringByKey("AXISFLAGS",ImageInfo(GraphName,StringFromList(0,ImagesGraphed,";"),0))+" "
		
	String Traces1 = TraceNameList(GraphName,";",1)
		
	Execute "AppendToGraph"+axNames+ "Y_coords vs X_coords"
		
	String Traces2 = TraceNameList(GraphName,";",1)
	Traces2=ReplaceString(";",RemoveFromList(Traces1,Traces2),"")
			
	Print Traces2
	GraphWaveEdit $Traces2

End



////////////////// THis needs to write to a folder /////////////////////
Function DFFAlongLoi(inwave,LOI_X,LOI_Y,firstBackground,lastBackground,[LOI_width])
	Wave inwave
	Wave LOI_X,LOI_Y
	Variable firstBackground,lastBackground
	Variable LOI_width

	If(ParamIsDefault(LOI_width))
		LOI_width=1
	EndIf
	
	Make/O W_ImageLineProfile,W_LineProfileX,W_sumRows 	
	Variable index

	If(Dimsize(inwave,2)==0)
		return 0
	EndIf

	ImageLineProfile/P=0 xWave=LOI_X,yWave=LOI_Y,width=LOI_width,srcwave=inwave
	Make/O/N=(dimsize(W_LineProfileX,0),dimsize(inwave,2)) Line_DFF
	Line_DFF[0,*][0]=W_ImageLineProfile[p]
	index+=1
		
	Do
		ImageLineProfile/P=(index) xWave=LOI_X,yWave=LOI_Y,width=LOI_width,srcwave=inwave
		Line_DFF[0,*][index]=W_ImageLineProfile[p]
	
		index+=1
	While(index<dimsize(inwave,2)) 

	
	Duplicate/O Line_DFF Line_outwave_DFF
	Duplicate/O/R=[0,*][firstBackground,lastBackground] Line_DFF baseWave
	ImageTransform sumAllRows baseWave
	W_sumRows/=(lastBackground-firstBackground+1)
	Line_DFF[0,*][0,*]=(Line_DFF[p][q]-W_sumRows[p])/W_sumRows[p] //W_sumRows[p]
		
End

/////////////////////// Function Show as Movie///////////////
///////////////////////// NEED TO MAKE SURE YOU'RE ALWAYS IN ROOT!!!!//////////////////////
Function ShowAsMovie(inwave,first,last,frameRate_ms)
	Wave inwave
	Variable frameRate_ms
	Variable first,last
	Variable dum_start
	SVAR MovieOnDisplay = root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	SVAR ColorTable = root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	Print "NAMEOFWAVE:  "+ NameOfWave(inwave)
	NVAR frameNumOfDisplayed = root:Globals:imaging:ImageAnalysisGlobals:FrameNumOfDisplayed
	Wave frameToShow = root:Globals:imaging:ImageAnalysisGlobals:frameToShow
	
	If(dimsize(inwave,2)==0)
		
		return 0
	Else
		
		frameNumOfDisplayed=0
		UpdateFrameViewer()
				
	EndIf

	String OpenGraphs = WinList("FrameViewer",";","WIN:1")
	
	
	FrameNumOfDisplayed =0
	
	Do
		UpdateFrameViewer()	
		dum_start=ticks	
		Do
			If(16.7*(ticks-dum_start)>frameRate_ms)	
				
				DoUpdate
				dum_start=ticks
				break
			EndIf
		While(1)
		
		FrameNumOfDisplayed+=1
		
	While (FrameNumOfDisplayed<last)	
	UpdateFrameViewer()

	FrameNumOfDisplayed=0
	UpdateFrameViewer()
End


////////////////////////////////// BUTTONS ////////////////////////////////////////////


	
Function SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	NVAR gRadioVal = root:Globals:imaging:ImageAnalysisGlobals:gRadioVal
	
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
			Switch (gRadioVal)
				
				case 1:
					MyCheckProc("All",1)
					break
				case 2:
					MyCheckProc("DFFonly",2)
					break
				case 3: 
					MyCheckProc("NoDFF",3)
					break
					
			EndSwitch		
			break
	endswitch

	return 0
End


////The Frame Viewer Popup

////PlayMovie Button
/////////////// Need to add the first and last as variables............. 

Function ButtonProc_7(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	NVAR FrameRate_ms = root:Globals:imaging:ImageAnalysisGlobals:FrameViewerSpeed
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	SVAR Movie = root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	
	
	String MovieOnDisplay = "root:"+ExperimentName+":imaging_data:"+Movie
	Variable first=1 // These shouldn't be hard-coded
	Variable last=dimsize($MovieOnDisplay,2)
	Variable index
	
	switch( ba.eventCode )
		case 2: // mouse up
			String topWave=StringFromList(0,ImageNameList("",";"))
			Wave ww=$topWave
			//RemoveAllImages()	

	
		
	

								
			ShowAsMovie($MovieOnDisplay,first,last,frameRate_ms)
		
	endswitch

	return 0
End

////////////////// COlor picker//////////////////////// Need to rename this

///////////////////// Use the new RemoveAll Images
Function PopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	SVAR MovieOnDisplay=root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	SVAR ColorTable = root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	NVAR FrameNumOfDisplayed= root:Globals:imaging:ImageAnalysisGlobals:FrameNumOfDisplayed
	NVAR gRadioVal_range =  root:Globals:imaging:ImageAnalysisGlobals:gRadioVal_range
	SVAR WorkingFolder = root:Globals:imaging:ImageAnalysisGlobals:WorkingFolder
		
		
	String tmpName=""
	Switch (gRadioVal_range)
		case 1:
			tmpName="Range_Auto"
			break
		case 2:
			tmpName="Range_94"
			break
		case 3:
			tmpName="Range_DFF"
			break
		default:
			break
	EndSwitch
	Print "CTRL NAME!!!!!" + tmpName

	
	FrameNumOfDisplayed=0
	
	
	Variable index
	//RemoveAllImages()
	RMIMages("FrameViewer_subwin")
	
	
	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			MovieOnDisplay = pa.popStr
			String FullWavePath = WorkingFolder + ":"+MovieOnDisplay
			Print FullWavePath	
			UpdateFrameViewer()
			// UDFrameViewer(destWindow,inWaveString,FrameNumber,outWaveName)
		//	UDFrameViewer("FrameViewer_subWin",
			SetAxis/A/W=FrameViewer_subwin left
			SetAxis/A/W=FrameViewer_subwin bottom
			RangeCheckProc(tmpName,gRadioVal_range)
			

			break	
	endswitch

	return 0
End


/// The Forward Button ////////////
////////////////////////////////// The "FRAME BEING DISPLAYED" wave should be global in the image analysis folder ////////////
Function ButtonProc_9(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	NVAR FrameNumOfDisplayed= root:Globals:imaging:ImageAnalysisGlobals:FrameNumOfDisplayed
	SVAR MovieOnDisplay = root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	SVAR ColorTable = root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	
	switch( ba.eventCode )
	
	
		case 2: // mouse down and held...
			
			
			If(FrameNumOfDisplayed>0)
				FrameNumOfDisplayed-=1
				UpdateFrameViewer()
		
			EndIf	
			
			
			break
	endswitch

	return 0
End



////////////// USE THIS INSTEAD OF WRITING IT SEPARATELY EACH TIME: 

Function RemoveAllImages()
	Variable index

	Do	// Don't know why RemoveImage is problematic... this is a pretty dumb kludge
		String ImageList=ImageNameList("",";")
		Do
			String thisImage=StringFromList(index,ImageList)
			If(strlen(thisImage)==0)
				break
			EndIf
				
			RemoveImage/Z $thisImage
			index+=1
		
		While(1)
		index=0
	While(strlen(ImageList)!=0)
End


Function PopMenuProc_1(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	SVAR MovieOnDisplay = root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	SVAR ColorTable=root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	Wave/Z FrameToShow = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow
	
	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			ColorTable = popStr
			
			ModifyImage FrameToShow ctab= {*,*,$popStr,0} 
			break
	endswitch

	return 0
End

//////////////////////// Automatically Pop up the appropriate frame ///////////
///////////// Again... make saavy for "frame Being Displayed" ///////////////
Function SetVarProc_1(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	NVAR frameNumOfDisplayed = root:Globals:imaging:ImageAnalysisGlobals:frameNumOfDisplayed
	SVAR MovieOnDisplay = Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	
	Wave/Z frameToShow = root:Globals:imaging:ImageAnalysisGlobals:frameToShow
	
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
			If ((frameNumOfDisplayed>=0) && (frameNumOfDisplayed <(dimsize($MovieOnDisplay,2))))
				UpdateFrameViewer()	
			
			ElseIf (frameNumOfDisplayed > dimsize($MovieOnDisplay,2))
				frameNumOfDisplayed=dimsize($MovieOnDIsplay,2)-1
				UpdateFrameViewer()
			EndIf
					
			
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			break
	endswitch

	return 0
End

Function UpdateFrameViewer()

	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	NVAR FrameNumOfDisplayed = root:Globals:imaging:ImageAnalysisGlobals:FrameNumOfDisplayed

	Wave/Z FrameToShow=root:Globals:imaging:ImageAnalysisGlobals:FrameToShow
	Wave contrast_lookup = root:Globals:imaging:ImageAnalysisGlobals:contrast_lookup
	SVAR ColorTable = root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	SVAR Movie = root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	
	Variable left_min,left_max,bot_min,bot_max
	String MovieOnDisplay = "root:"+ ExperimentName + ":imaging_data:"+Movie
	
	If(Strlen(ExperimentName)==0 || !WaveExists(FrameToShow))
		return 0
	EndIf
		
	
	GetAxis/Q/W=FrameViewer_subwin left; left_min=V_min;left_max=V_max
	GetAxis/Q/W=FrameViewer_subwin bottom; bot_min=V_min;bot_max=V_max
	
			
	//RemoveAllImages()
	RMImages("FrameViewer_subwin")
	
	Duplicate/O/R=[0,*][0,*][FrameNumOfDisplayed,FrameNumOfDisplayed] $MovieOnDisplay FrameToShow 
	
	AppendImage FrameToShow
	ModifyImage FrameToShow ctab={nzmin,nzmax,$ColorTable}, lookup=contrast_lookup
	SetAxis left, left_min,left_max
	SetAxis bottom, bot_min,bot_max
	
End


Function AutoRange(inwave,mode)
	Wave inwave
	String mode
	String histWave=NameOfWave(inwave)+"_hist"
	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave/Z FrameToShow=root:Globals:imaging:ImageAnalysisGlobals:FrameToShow

	Make/O/N=100 $histWave

	Histogram/B=1 inwave, $histWave
	Wave histw=$histWave
	Variable tot=sum(histw,pnt2x(histw,0),pnt2x(histw,numpnts(histw)-1))

	Strswitch (mode)	
	
		case "94":

			///////// Code below is duplication from Wavemetrics ImageRangeAdjust.ipf  ////////
			variable s=0,i=0
			do
				s += histw[i]
				i+=1
			while( (s/tot) < 0.03 )
			nzmin= LeftX(histw)+deltax(histw)*i
	
			s=0;i=numpnts(histw)-1
			do
				s += histw[i]
				i-=1
			while( (s/tot) < 0.03 )
			nzmax= LeftX(histw)+deltax(histw)*i

			ModifyImage frameToShow ctab= {nzmin,nzmax,}
			break

		case "Auto":
			nzmax=Rightx(histw)
			nzmin=Leftx(histw)
			ModifyImage frameToShow ctab= {nzmin,nzmax,}// {*,*,}
			break
		
		case "2SD":
			Imagestats/Q frameToShow
			nzmax=V_avg+V_sdev/2
			nzmin = V_avg-2*V_sdev/2
			ModifyImage frameToShow ctab= {nzmin,nzmax,}// {*,*,}
			break
		default:
			break
	endswitch	
	
End

////////// Make this one of the switch cases above.... ////////////////
Function AutoRangeDFF()

	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave FrameToShow = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow

	nzmax=.3;nzmin=-.1
	ModifyImage frameToShow ctab={nzmin,nzmax,}
End




Function ChangeImageRange(direction)
	String Direction

	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave FrameToShow  = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow

	strswitch(direction)
		case "Down":
			nzmax*=1.03
			nzmin*=1.03
			break

		case "Up":
			nzmax*=.97
			nzmin*=.97
			break

		default:
			break

	endswitch
	ModifyImage frameToShow ctab={nzmin,nzmax,}

End

Function BrightnessButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			If(StringMatch(ba.ctrlName,"Brighter"))
				ChangeImageRange("Up")
			ElseIf (StringMatch(ba.ctrlName,"Darker"))
				ChangeImageRange("Down")
			EndIf
			
			break
	endswitch

	return 0
End

Function InvertContrast()
	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave FrameToShow  = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow	
	Wave contrast_lookup=root:Globals:imaging:ImageAnalysisGlobals:contrast_lookup
	Redimension/N=(1000) contrast_lookup;SetScale/I x,0,1,contrast_lookup
	contrast_lookup=1-x		
	ModifyImage frameToShow ctab={nzmin,nzmax,},lookup=contrast_lookup
	
End

Function LinearContrast()
	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave FrameToShow  = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow	
	Wave contrast_lookup = root:Globals:imaging:ImageAnalysisGlobals:contrast_lookup
	contrast_lookup=x
	ModifyImage frameToShow ctab={nzmin,nzmax,},lookup=contrast_lookup
End

Function GammaContrast()
	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave FrameToShow  = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow	
	NVAR gamma_val = root:Globals:imaging:ImageAnalysisGlobals:gamma_val
	Wave/Z contrast_lookup=root:Globals:imaging:ImageAnalysisGlobals:contrast_lookup
	Redimension/N=(1000) contrast_lookup;SetScale/I x,0,1,contrast_lookup
	
	contrast_lookup=x^(1/gamma_val)
	ModifyImage frameToShow ctab={nzmin,nzmax,}, lookup=contrast_lookup
	
End


Function Contrast_popup(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	ControlInfo gamma_val
	Print pa
		
		
	
	switch( pa.eventCode )
		case 2: // mouse up
			strswitch(pa.popStr)
			
				case "Linear":
					LinearContrast()
					V_disable = V_disable | 0x1
					//ModifyControl "gammaVal" 
					break
			
				case "Invert":
					InvertContrast()
					V_disable = V_disable | 0x1
					break
			
				case "Gamma":
					GammaContrast()
					V_disable = V_disable & ~0x1
					break
				
				default:
					break
				
			endswitch
			
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			break
	endswitch
	
	
	ModifyControl/Z  Gamma_val, win=FrameViewer_subWin#ImageControls, disable=V_disable
	
	return 0
End





////////////////// This function will Apply relevant settings for an image that popped up
/////////////// Make sure things are set up (elsewhere) so that contrast (94%,Auto), etc, is applied to the new wave..)


Function ApplyImageSettings()
	SVAR ColorTable = root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	NVAR nzmax = root:Globals:imaging:ImageAnalysisGlobals:nzmax
	NVAR nzmin = root:Globals:imaging:ImageAnalysisGlobals:nzmin
	Wave contrast_lookup = root:Globals:imaging: ImageAnalysisGlobals:contrast_lookup
	Wave/Z frameToShow =root:Globals:imaging:ImageAnalysisGlobals: frameToShow

	ModifyImage frameToShow ctab={nzmin,nzmax,}, lookup=contrast_lookup

End




//Window FrameViewer() : Graph
//	PauseUpdate; Silent 1		// building window...
//	MakeImageAnalysisGlobals()
//	Display /W=(446.25,50.75,927,452.75)
//	AppendImage root:Globals:imaging:ImageAnalysisGlobals:frameToShow
//	ModifyImage frameToShow ctab= {2320,9538,Grays,0},lookup= root:Globals:imaging:ImageAnalysisGlobals:contrast_lookup
//	ModifyGraph mirror=2
//	ControlBar 93
//	GroupBox group2,pos={3,2},size={75,45},labelBack=(52224,52224,52224)
//	GroupBox group2,fColor=(65280,0,0)
//	CheckBox DFFonly,pos={7,19},size={65,14},proc=MyCheckProc,title="\\F'Symbol'D\\F'Arial' F/F only"
//	CheckBox DFFonly,fSize=10,value= 0,mode=1
//	CheckBox NoDff,pos={7,33},size={55,14},proc=MyCheckProc,title="\\F'Arial'No \\F'Symbol'D\\F'Arial'F/F"
//	CheckBox NoDff,fSize=10,value= 1,mode=1
//	CheckBox All,pos={7,4},size={68,14},proc=MyCheckProc,title="All images"
//	CheckBox All,font="Arial",fSize=10,value= 0,mode=1
//	GroupBox group3,pos={90,2},size={166,87},labelBack=(52224,52224,52224)
//	GroupBox group3,fColor=(65535,65535,65535)
//	SetVariable setvar1,pos={100,39},size={110,19},proc=SetVarProc,title="Stem"
//	SetVariable setvar1,fSize=13,value= root:Globals:imaging:ImageAnalysisGlobals:ImageStem
//	PopupMenu popup2,pos={215,10},size={21,21},proc=PopMenuProc
//	PopupMenu popup2,mode=0,value= #"root:Globals:imaging:ImageAnalysisGlobals:showInViewer"
//	TitleBox title1,pos={113,12},size={40,16},fSize=13,frame=0
//	TitleBox title1,variable= root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
//	GroupBox group4,pos={97,8},size={144,26},fColor=(65535,65535,65535)
//	GroupBox group5,pos={98,37},size={144,23}
//	PopupMenu popup0,pos={98,64},size={145,21},proc=PopMenuProc_1
//	PopupMenu popup0,mode=1,bodyWidth= 145,popvalue="",value= #"\"*COLORTABLEPOP*\""
//	GroupBox group6,pos={258,2},size={68,88},labelBack=(52224,52224,52224)
//	GroupBox group6,fColor=(65535,65535,65535)
//	Button forward,pos={295,57},size={26,25},proc=ButtonProc_8,title=">>",fSize=16
//	Button forward,fStyle=1
//	Button backward,pos={262,57},size={26,25},proc=ButtonProc_9,title="<<",fSize=16
//	Button backward,fStyle=1
//	SetVariable FrameNum,pos={275,32},size={35,23},proc=SetVarProc_1,title=" "
//	SetVariable FrameNum,fSize=16,format="%g"
//	SetVariable FrameNum,limits={0,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:frameNumOfDisplayed
//	TitleBox title,pos={270,11},size={44,16},title="Frame",fSize=15,frame=0,fStyle=1
//	TitleBox title,fColor=(30464,30464,30464)
//	GroupBox group7,pos={3,48},size={75,43},labelBack=(52224,52224,52224)
//	GroupBox group7,fColor=(65280,0,0)
//	Button Play_Movie1,pos={13,69},size={56,17},proc=ButtonProc_7,title="Play"
//	Button Play_Movie1,labelBack=(52224,52224,52224),fSize=14
//	Button Play_Movie1,fColor=(65535,65535,65535)
//	Slider MovieSpeed1,pos={13,53},size={57,13}
//	Slider MovieSpeed1,limits={100,10,1},variable= root:Globals:imaging:ImageAnalysisGlobals:FrameViewerSpeed,side= 0,vert= 0,ticks= 0,thumbColor= (0,15872,65280)
//	GroupBox group0,pos={333,38},size={224,48},labelBack=(52224,52224,52224)
//	CheckBox Range_94,pos={510,55},size={38,14},proc=RangeCheckProc,title="94%"
//	CheckBox Range_94,value= 0,mode=1
//	CheckBox Range_Auto,pos={510,41},size={40,14},proc=RangeCheckProc,title="Auto"
//	CheckBox Range_Auto,value= 1,mode=1
//	CheckBox Range_DFF,pos={510,69},size={38,14},proc=RangeCheckProc,title="DFF"
//	CheckBox Range_DFF,value= 0,mode=1
//	SetVariable Max2,pos={393,43},size={94,16},title="Max",fSize=9
//	SetVariable Max2,limits={0,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:nzmax,bodyWidth= 70
//	SetVariable Max3,pos={393,65},size={93,16},title="Min",fSize=9
//	SetVariable Max3,limits={-2,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:nzmin,bodyWidth= 72
//	Button Brighter,pos={340,44},size={28,16},proc=BrightnessButtonProc,title="\\W617"
//	Button Brighter,labelBack=(52224,52224,52224),fSize=10
//	Button Darker,pos={340,65},size={28,16},proc=BrightnessButtonProc,title="\\W623"
//	Button Darker,labelBack=(52224,52224,52224),fSize=10
//	GroupBox group1,pos={333,2},size={225,34},labelBack=(52224,52224,52224)
//	PopupMenu ContrastPicker,pos={395,11},size={73,21},proc=Contrast_popup,fSize=8
//	PopupMenu ContrastPicker,mode=3,popvalue="Gamma",value= #"\"Linear;Invert;Gamma\""
//	TitleBox title3,pos={336,13},size={57,16},title="Contrast",fSize=15,frame=0
//	TitleBox title3,fStyle=1,fColor=(30464,30464,30464)
//	SetVariable Gamma_val,pos={475,13},size={79,16},proc=Gamma_setVar,title="gamma"
//	SetVariable Gamma_val,limits={-inf,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:gamma_val
//	SetDrawLayer UserFront
//	SetDrawEnv translate= 0.473529,-0.088586,rotate= -11.841,rsabout
//	SetDrawEnv save
//	SetDrawEnv save
//	NewPanel/HOST=#/EXT=2/W=(0,0,289,65) 
//	ModifyPanel fixedSize=0
//	GroupBox group0,pos={4,7},size={277,49},labelBack=(52224,52224,52224)
//	GroupBox group0,fColor=(52224,52224,52224)
//	Button button5,pos={7,14},size={50,34},title="DF/F",fColor=(65280,0,0)
//	Button button6,pos={61,14},size={50,34},title="ROI",fColor=(32768,40704,65280)
//	Button button7,pos={116,14},size={50,34},title="LOI",fColor=(26112,52224,0)
//	Button button8,pos={170,14},size={50,34},title="Movie"
//	Button button8,fColor=(44032,29440,58880)
//	Button button9,pos={225,14},size={50,34},title="Plotter"
//	RenameWindow #,QuickTabs
//	SetActiveSubwindow ##
//EndMacro

///////////////////////////////// THIS PANEL IS BETTER: DON'T GET FLICKER during movies /////////////////////////

Function AcqMakeFrameViewer()
	InitializeExperiment()
	PauseUpdate; Silent 1		// building window...
	Display/N=FrameViewer_subWin /W=(643.5,170.75,1033.5,517.25) as "Frame Viewer"
	AppendImage root:Globals:imaging:ImageAnalysisGlobals:frameToShow
	ModifyImage frameToShow ctab= {3035.9,3275.3,Grays,0}
	ModifyImage frameToShow lookup= :Globals:imaging:ImageAnalysisGlobals:contrast_lookup
	ModifyGraph mirror=2
	SetAxis left -0.5,169.5
	SetAxis bottom -0.5,169.5
	SetDrawLayer UserFront
	SetDrawEnv translate= 0.473529,-0.088586,rotate= -11.841,rsabout
	SetDrawEnv save
	SetDrawEnv save
	NewPanel/HOST=#/EXT=2/W=(0,0,287,68) 
	ModifyPanel fixedSize=0
	GroupBox group0,pos={4,7},size={277,49},labelBack=(52224,52224,52224)
	GroupBox group0,fColor=(52224,52224,52224)
	Button button5,pos={8,14},size={50,34},proc=DFF_QuickTab,title="DF/F"
	Button button5,fColor=(13056,0,0)
	Button button6,pos={61,14},size={50,34},proc=ROI_QuickTab,title="ROI"
	Button button6,labelBack=(0,3072,13056),fColor=(0,6400,26112)
	Button button7,pos={116,14},size={50,34},title="LOI",fColor=(6400,13056,0)
	Button button8,pos={170,14},size={50,34},title="Movie",fColor=(13056,0,26112)
	Button button9,pos={225,14},size={50,34},title="Plotter"
	RenameWindow #,QuickTabs
	SetActiveSubwindow ##
	NewPanel/HOST=#/EXT=3/W=(0,97,563,0) 
	ModifyPanel fixedSize=0
	SetDrawLayer ProgBack
	SetDrawEnv linethick= 1.5,linefgc= (65280,65535,65535),fillpat= 0
	DrawRect 118.104651162791,161,155.882428940568,122
	DrawText 118.104651162791,162,"ROI"
	SetDrawLayer UserBack
	SetDrawEnv linefgc= (34816,34816,34816),fillpat= 0
	DrawRect 97,36,243,59
	SetDrawEnv linefgc= (34816,34816,34816),fillpat= 0
	DrawRect 97,8,243,31
	GroupBox group2,pos={3,2},size={75,45},labelBack=(52224,52224,52224)
	GroupBox group2,fColor=(65280,0,0)
	CheckBox DFFonly,pos={7,19},size={65,14},proc=MyCheckProc,title="\\F'Symbol'D\\F'Arial' F/F only"
	CheckBox DFFonly,fSize=10,value= 0,mode=1
	CheckBox NoDff,pos={7,33},size={55,14},proc=MyCheckProc,title="\\F'Arial'No \\F'Symbol'D\\F'Arial'F/F"
	CheckBox NoDff,fSize=10,value= 0,mode=1
	CheckBox All,pos={7,4},size={68,14},proc=MyCheckProc,title="All images"
	CheckBox All,font="Arial",fSize=10,value= 1,mode=1
	GroupBox group3,pos={87,2},size={164,91},labelBack=(52224,52224,52224)
	GroupBox group3,fColor=(65535,65535,65535)
	SetVariable setvar1,pos={100,38},size={110,20},proc=SetVarProc,title="Stem"
	SetVariable setvar1,fSize=13
	SetVariable setvar1,value= root:Globals:imaging:ImageAnalysisGlobals:ImageStem
	PopupMenu popup2,pos={221,10},size={21,21},proc=PopMenuProc
	PopupMenu popup2,mode=0,value= #"root:Globals:imaging:ImageAnalysisGlobals:showInViewer"
	TitleBox title1,pos={103,14},size={1,1},fSize=10,frame=0
	TitleBox title1,variable= root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	PopupMenu popup0,pos={98,64},size={147,21},proc=PopMenuProc_1
	PopupMenu popup0,mode=3,bodyWidth= 147,popvalue="",value= #"\"*COLORTABLEPOP*\""
	GroupBox group6,pos={258,4},size={68,91},labelBack=(52224,52224,52224)
	GroupBox group6,fColor=(65535,65535,65535)
	Button forward,pos={295,43},size={27,16},proc=ButtonProc_8,title=">>",fSize=16
	Button forward,fStyle=1
	Button backward,pos={263,43},size={27,16},proc=ButtonProc_9,title="<<",fSize=16
	Button backward,fStyle=1
	SetVariable FrameNum,pos={274,23},size={35,20},proc=SetVarProc_1,title=" "
	SetVariable FrameNum,fSize=14,format="%g"
	SetVariable FrameNum,limits={0,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:frameNumOfDisplayed
	TitleBox title,pos={270,7},size={44,16},title="Frame",fSize=15,frame=0,fStyle=1
	TitleBox title,fColor=(30464,30464,30464)
	GroupBox group7,pos={4,50},size={75,43},labelBack=(52224,52224,52224)
	GroupBox group7,fColor=(65280,0,0)
	Button Play_Movie1,pos={13,73},size={57,18},proc=ButtonProc_7,title="Play"
	Button Play_Movie1,labelBack=(52224,52224,52224),fSize=12
	Button Play_Movie1,fColor=(65535,65535,65535)
	Slider MovieSpeed1,pos={13,52},size={57,21}
	Slider MovieSpeed1,limits={100,10,1},variable= root:Globals:imaging:ImageAnalysisGlobals:FrameViewerSpeed,side= 0,vert= 0,ticks= 0,thumbColor= (0,15872,65280)
	GroupBox group0,pos={333,38},size={224,55},labelBack=(52224,52224,52224)
	CheckBox Range_94,pos={512,55},size={38,14},proc=RangeCheckProc,title="94%"
	CheckBox Range_94,value= 0,mode=1
	CheckBox Range_Auto,pos={512,41},size={40,14},proc=RangeCheckProc,title="Auto"
	CheckBox Range_Auto,value= 1,mode=1
	CheckBox Range_DFF,pos={512,69},size={38,14},proc=RangeCheckProc,title="DFF"
	CheckBox Range_DFF,value= 0,mode=1
	SetVariable Max2,pos={393,43},size={94,16},title="Max",fSize=9
	SetVariable Max2,limits={0,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:nzmax,bodyWidth= 70
	SetVariable Max3,pos={393,65},size={93,16},title="Min",fSize=9
	SetVariable Max3,limits={-2,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:nzmin,bodyWidth= 72
	Button Brighter,pos={340,44},size={28,16},proc=BrightnessButtonProc,title="\\W617"
	Button Brighter,labelBack=(52224,52224,52224),fSize=10
	Button Darker,pos={340,65},size={28,16},proc=BrightnessButtonProc,title="\\W623"
	Button Darker,labelBack=(52224,52224,52224),fSize=10
	GroupBox group1,pos={333,2},size={225,34},labelBack=(52224,52224,52224)
	PopupMenu ContrastPicker,pos={400,9},size={66,21},proc=Contrast_popup,fSize=8
	PopupMenu ContrastPicker,mode=1,popvalue="Linear",value= #"\"Linear;Invert;Gamma\""
	TitleBox title3,pos={335,11},size={57,16},title="Contrast",fSize=15,frame=0
	TitleBox title3,fStyle=1,fColor=(30464,30464,30464)
	SetVariable Gamma_val,pos={477,13},size={79,16},disable=1,proc=Gamma_setVar,title="gamma"
	SetVariable Gamma_val,limits={-inf,inf,0},value= root:Globals:imaging:ImageAnalysisGlobals:gamma_val
	PopupMenu popup1,pos={261,65},size={63,21},proc=DataFolderList_popup,title="folder",value=folderList(),mode=0
	
	RenameWindow #,ImageControls
	SetActiveSubwindow ##
EndMacro
DoWindow/F FrameViewer_subWin
If(V_Flag==1)
	return 0
EndIf
		

// Radio Button to set which type of images to show (DFF, non-DFF..) 
Function MyCheckProc(name,value):CheckBoxControl
	String name
	Variable value
	
	
	
	NVAR gRadioVal= root:Globals:imaging:ImageAnalysisGlobals:gRadioVal
	SVAR showInViewer=root:Globals:imaging:ImageAnalysisGlobals:showInViewer
	SVAR ImageStem = root:Globals:imaging:ImageAnalysisGlobals:ImageStem
	SVAR zapString = root:Globals:imaging:ImageAnalysisGlobals:zapString
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	
	String dfSav = GetDataFolder(1)
	
	String PathToExperiment = "root:"+ExperimentName+":imaging_data"

	If(DataFolderExists(PathToExperiment))
		SetDataFolder PathToExperiment
		Variable IsSetUp=1
	EndIf
	
	
	String GrepTest 
	
	Strswitch(name)
		case "All":
			gRadioVal= 1
			
			If (IsSetUp)
				showInViewer=WaveList(ImageStem+"*",";","MINCOLS:1")
			Else
				showInViewer=""
			EndIf
				
			break
		
		case "DFFonly":
			gRadioVal= 2 
			
			If (IsSetUp)
				showInViewer=WaveList(ImageStem+"*_DFF",";","MINCOLS:2")
			Else
				showInViewer=""
			EndIf
				
			break
		
		case "NoDFF":
			gRadioVal= 3
			
			If (IsSetUp)
				String StringToGrep = WaveList(ImageStem+"*",";","MINCOLS:1")
				showInViewer=GrepList(StringToGrep,"_DFF",1)
			Else
				showInViewer=""
			EndIf
			break
	endswitch
	
	CheckBox All,Win=FrameViewer_subWin#ImageControls,value= gRadioVal==1
	CheckBox DFFonly,Win=FrameViewer_subWin#ImageControls,value= gRadioVal==2
	CheckBox NoDFF,Win=FrameViewer_subWin#ImageControls,value= gRadioVal==3
	
	SetDataFolder dfSav
End

Function RangeCheckProc(name,value):CheckBoxControl
	String name
	Variable value
	NVAR gRadioVal_range= root:Globals:imaging:ImageAnalysisGlobals:gRadioVal_range
	SVAR showInViewer=root:Globals:imaging:ImageAnalysisGlobals:showInViewer
	SVAR ImageStem = root:Globals:imaging:ImageAnalysisGlobals:ImageStem
	SVAR zapString = root:Globals:imaging:ImageAnalysisGlobals:zapString
	Wave frameToShow =root:Globals:imaging:ImageAnalysisGlobals:frameToShow // Make this global within a folder...  
	
	String GrepTest 
	
	Strswitch(name)
		case "Range_Auto":
			gRadioVal_range= 1
			AutoRange(frameToShow,"Auto")	
				
			break
		case "Range_94":
			gRadioVal_range= 2 
			AutoRange(frameToShow,"94")	
			break
			
		case "Range_DFF":
			gRadioVal_range= 3
			AutoRangeDFF()	// change this to be a subset of the function AutoRange()// 
			break
			
	endswitch

	
	CheckBox Range_Auto,win=FrameViewer_subWin#ImageControls, value= gRadioVal_range==1
	CheckBox Range_94,win=FrameViewer_subWin#ImageControls, value= gRadioVal_range==2
	CheckBox Range_DFF,win=FrameViewer_subWin#ImageControls, value= gRadioVal_range==3
	Print showInViewer
	
End

Function ButtonProc_8(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	NVAR FrameNumOfDisplayed= root:Globals:imaging:ImageAnalysisGlobals:FrameNumOfDisplayed
	NVAR mouseHeld=root:Globals:imaging:ImageAnalysisGlobals:mouseHeld
	SVAR Movie = root:Globals:imaging:ImageAnalysisGlobals:MovieOnDisplay
	SVAR ColorTable = root:Globals:imaging:ImageAnalysisGlobals:ColorTable
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	Wave FrameToShow = root:Globals:imaging:ImageAnalysisGlobals:FrameToShow
	
	String MovieOnDisplay = "root:"+ExperimentName+":imaging_data:"+ Movie
	
	Variable left_min,left_max,bot_min,bot_max
		
	switch( ba.eventCode )
		case 2: // mouse down
		
			If(FrameNumOfDisplayed<(dimsize($MovieOnDisplay,2)-1))
				
			
				FrameNumOfDisplayed+=1
				Duplicate/O/R=[0,*][0,*][FrameNumOfDisplayed] $MovieOnDisplay frameToShow
				UpdateFrameViewer()
				

			ElseIf(FrameNumOfDisplayed>dimsize($MovieOnDisplay,2)-1)
				FrameNumOfDisplayed=dimsize($MovieOnDisplay,2)-1
				Duplicate/O/R=[0,*][0,*][FrameNumOfDisplayed] $MovieOnDisplay frameToShow
				UpdateFrameViewer()

			EndIf
			
				
			break
	endswitch

	return 0
End

Function Gamma_setVar(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
	
		case 2: // Enter key
		
			ControlInfo ContrastPicker
			If(Stringmatch(S_value,"Gamma"))
				Print "SVAL+" + S_value
				GammaContrast()
			EndIf
				
			
		
	endswitch

	return 0
End

/////// Functions for contrast.... work better as buttons than RadioVals... ///////////

Function AutoRange_Button(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			
				
		
		break
	
	endswitch

	return 0
End


Function/S FolderList()	

String dfSav = GetDataFolder(1)

String FolderList = ""

Variable totalFolders = CountObjects("root:",4)
Variable index

	Do
		String thisFolder = GetindexedObjName("root:", 4, index)
		
		If(strlen(thisFolder)==0)
			break
		EndIf
		FolderList=FolderList+";"+thisFolder
		
		index+=1
		
	While(1)

SetDataFolder dfSav
	
Return FolderList
	
End

Function DataFolderList_popup(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	
	SVAR WorkingFolder = root:Globals:Imaging:ImageAnalysisGlobals:WorkingFolder
	
	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			break
	endswitch

	WorkingFolder = "root:" + popStr
	
	return 0
End

////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////

Function UDFrameViewer(destWindow,inWaveString,FrameNumber,outWaveName)
String destWindow
String inWaveString
Variable FrameNumber

String outWaveName // Name of the 1-D wave to be written

////////// Test to make sure parameters are reasonable.... ////// 

String destWindowMatch = WinList(destWindow,";","WIN:1")

	If(Strlen(destWindowMatch)==0)	// No such window?
		Print "Busted"
		return 0
	EndIf

 	If(!(WaveExists($inWaveString)))	// No such wave
 		Print "Busted"
 		return 0
 	Else
 		Wave inwave=$inWaveString
 	EndIf
 		

	If(FrameNumber>dimsize($inWaveString,2)-1)
		Print "Busted"
		return 0
	EndIf
	
	
Variable left_min,left_max,bot_min,bot_max
	
	GetAxis/Q/W=$destWindow left;left_min=V_min;left_max=V_max
	GetAxis/Q/W=$destWindow bottom; bot_min=V_min;bot_max=V_max
	
	RMImages(destWindow)
	
	Duplicate/O/R=[0,*][0,*][FrameNumber,FrameNumber] inWave $outWaveName
	
	AppendImage/W=$destWindow $outWaveName
	
	SetAxis/W=$destWindow left left_min,left_max
	SetAxis/W=$destWindow bottom bot_min,bot_max
	
End


Function AppImageSettings(destWindow,contrastLookup,nzMin,nzMax,colorTable,theWave)
String destWindow
String contrastLookup
Variable nzMin,nzMax
String colorTable
String theWave

String destWindowMatch = WinList(destWindow,";","WIN:1")

	If(Strlen(destWindowMatch)==0)	// No such window?	
		return 0
	EndIf
	
	String localWvName = NameOfWave($theWave)
		
	
	If(FindListItem(localWvName,ImageNameList(destWindow,";"))==-1)
	
		return 0
	Else

		ModifyImage/W=$destWindow $localWvName, ctab={nzMin,nzMax,$ColorTable},lookup=$contrastLookup
	EndIf
	
	
//String ImageNameList
//	ModifyImage/W=$destWindow $theWave

End


Function RMImages(destWindow)
String destWindow

String destWindowMatch = WinList(destWindow,";","WIN:1")

	If(Strlen(destWindowMatch)==0)	// No such window?
		return 0
	EndIf

Variable index

	Do	// Don't know why RemoveImage is problematic... this is a pretty dumb kludge
		String ImageList=ImageNameList(destWindow,";")
				
		Do
			String thisImage=StringFromList(index,ImageList)
			If(strlen(thisImage)==0)
				break
			EndIf
				
			RemoveImage/Z $thisImage
			index+=1
		
		While(1)
		
		index=0
	
	While(strlen(ImageList)!=0)

End