#pragma rtGlobals=1		// Use modern global access method.
#pragma version = 1.0
// Last Mod: 10/8/07 (JBC)


Function MakeRunGlobals()
	String savDF = GetDataFolder(1)
		
	If(DataFolderExists("root:Globals:physiology:Run_globals"))
		SetDataFolder root:Globals:physiology:Run_globals
	Else
		NewDataFolder/S root:Globals:physiology:Run_globals
		If(exists("Group Name")==0)
		
			String/G GroupName="foo"
			String/G ExperimentName=""
			String/G lastSavedGroup = ""
			Variable/G SweepLength=1000
			Variable/G SamplingInterval=0.1
			Variable/G SweepInterval=6
			Variable/G CurrentSweepNumber
			Variable/G ImagingIsOn
			Variable/G TillLampPresent
			Variable/G IlluminationChannel
			Variable/G TillLamp_Lambda=540
			Variable/G totalSweeps=1
			Variable/G ITCSend_time
			Variable/G firstSweepTick
			Variable/G presentDimSize
			Variable/G SaveMode
			Variable/G AutoTrigger=1
			Variable/G gRadioVal_triggering
			Variable/G TriggerChannel
		EndIf
	EndIf		
	SetDataFolder savDF		
End


///////////Makes sure things are hunky-dory and then launches the ITC based aquisition
Function InitAndAcquireSweep()

SetDataFolder root:	

///////////////// GLOBALS////////////////////////////////////////////////////////////////////
Wave/T DAC_combo_list = root:Globals:physiology:DAC_ADC_globals:DAC_combo_list
SVAR DACString_out = root:Globals:physiology:DAC_ADC_globals:DACString_out
SVAR ADCString_out = root:Globals:physiology:DAC_ADC_globals:ADCString_out
SVAR DACGainString_out = root:Globals:physiology:DAC_ADC_globals:DACGainString_out
NVAR SweepLength = root:Globals:physiology:Run_globals:SweepLength
NVAR SamplingInterval = root:Globals:physiology:Run_globals:SamplingInterval
NVAR SweepNumber = root:Globals:physiology:Run_globals:CurrentSweepNumber
NVAR ITCSend_time=root:Globals:physiology:Run_globals:ITCSend_time
Wave/Z muxed_wave /// perhaps this needs to go in  its own little folder???
///////////////////////////////////////////////////////////////////////////////////////////////////	

Variable totalPoints = SweepLength/SamplingInterval // define the # points to send to the ITC
	
InitializeStringsForSweep()	// Update gain strings, out strings, in strings

Variable ITCPer = (1000*SamplingInterval)/(1.25*strlen(ADCString_out) // Period for ITC18 (depends on # channels active)

Multiplex_wavelist(DAC_combo_list,DACGainString_out,SweepNumber,totalPoints) // mux the list

Duplicate/O muxed_wave inputWave; inputWave=0

Execute "ITC18seq"+" \""+ DACString_out+"\",\""+ADCString_out+"\""	
Execute  "ITC18StimAndSample muxed_wave, inputWave,"+ num2str(ITCPer) + ",2,0"

DeMultiplex(inputWave)

End

//////////////// Does what it says: ///////////////////////////////////
Function AcquireOneSweep()
	NVAR ImagingIsOn = root:Globals:physiology:Run_globals:ImagingIsOn
	NVAR frames=root:Globals:imaging:CameraParameterGlobals:num_frames
	NVAR x_pixels=root:Globals:imaging:CameraParameterGlobals:x_pixels
	NVAR y_pixels=root:Globals:imaging:CameraParameterGlobals:y_pixels
	NVAR CurrentSweep=root:Globals:physiology:Run_globals:CurrentSweepNumber
	NVAR PresentDimSize = root:Globals:physiology:Run_globals:PresentDimSize
	SVAR ExperimentName= root:Globals:physiology:Run_globals:ExperimentName
	SVAR GroupName=root:Globals:physiology:Run_globals:GroupName
	NVAR SaveMode=root:Globals:physiology:Run_globals:SaveMode
	SVAR lastSavedGroup = root:Globals:physiology:Run_globals:lastSavedGroup
	
	NVAR num_frames = root:Globals:imaging:CameraParameterGlobals:num_frames
	NVAR BinX = root:Globals:imaging:CameraParameterGlobals:X_pixels
	NVAR BinY = root:Globals:imaging:CameraParameterGlobals:Y_pixels
	NVAR exposure_time = root:Globals:imaging:CameraParameterGlobals:exposure_time
	
	
	
	Wave/T ImageList = $"root:"+ExperimentName  +":ImageList"
	
	String Wave_Image = "WaveImage"

	If(!ImagingIsOn)	// Not imaging on this sweep? 
		InitAndAcquireSweep()	// Collect just the phys sweeps
	Else
		
		If(!DataFolderExists("root:globals:Imaging:CameraHandleGlobals"))
			InitializeCamera()
		EndIf
		
		cameraParameters()
	
		Variable status
		String message
		Variable roi_index,utc_time
	
		NVAR camera_handle=root:Globals:imaging:CameraHandleGlobals:GCamera_handle
		NVAR sidx_handle=root:Globals:imaging:CameraHandleGlobals:GSIDX_handle
		
		
	
		SIDXTriggerSet camera_handle,3,status	// Camera is now waiting .........
	
		SIDXAcquisitionBeginSequence camera_handle, frames,status // prep the camera for acquisition of "frames" # of frames
	
		If(status!=0)	// if above didn't work
			SIDXCameraGetStatusText camera_handle,status,message
			DeallocateCamera()	// kill the camera handle
			printf"%s:%s","SIDXAcquisitionBeginSequence",message
			return 0
		EndIf

		////////////////////// At some point in here, will be good to make a wave note so time stamps can be compared ////////////////
		//////////////////////////////////////////////////////////////////////////////
		
		Variable bytes, index
		Variable locked, hardware_provided, temperature
		roi_index=0 // Will have to change this later when ROIs are incorporated. 


		Variable done_count
		SIDXAcquisitionStart camera_handle, status // let er' rip... camera will be waiting for a trigger. User is responsible for including the trigger 
		// as one of the TTL waves
	
		InitAndAcquireSweep()	// Commands sent to ITC, etc... should include a trigger
	
	
		Do

			SIDXAcquisitionFramesAvailable camera_handle,done_count,status	// wait until the frames are ready to be read into a wave..
		
			if(status!=0)
			
				TerminateAcquisition()
				//DeallocateCamera()
				return 0
			EndIf
		
		While(!done_count)

		//String destName = "root:"+ExperimentName+":imaging_data:"+
		String destFolder = "root:" + ExperimentName + ":imaging_data:" 
		String WvName= GroupName+"_im"+num2str(CurrentSweep)
		
		WriteAvailableImages(WvName,destFolder)
		
		imageList[dimsize(imageList,0)-1][0]=WvName
		imageList[dimsize(imageList,0)-1][1] = "Frames:"+ num2str(num_frames) + ";BinX:"+num2str(BinX)+";BinY:"+num2str(BinY)+";exposure time:"+num2str(exposure_time)+";Collected at:"+time()
		
		Print "root:"+ExperimentName+":ImageList"
		Redimension/N=(dimsize(imageList,0)+1,2) imageList	
		
//		
//		SIDXAcquisitionStop camera_handle	// kill the acquisition
//		SIDXAcquisitionGetFrames camera_handle,frames,roi_index,$wave_image,utc_time,status	//.. and write to an IGOR wave... need to make this more global and Aware of ROIs
		Wave/Z ww = $wave_image
		
		
		// Fix this up... 
		
//		Switch(SaveMode)
//		
//			case 0:
//				break
//				
//			case 1:
//				
//				lastSavedGroup = GroupName
//				String fullPath = "root:"+ExperimentName+":imaging_data:"
//				String fullWaveName = fullPath+GroupName+"_im"+num2str(currentSweep)
//				
//				If(CurrentSweep==0)
//				
//					KillWavesByMatch(GroupName,fullPath)
//				
//				EndIf
//				
//				Duplicate/O ww $fullWaveName
//				
//				break
//				
//			case 2:
//				lastSavedGroup = GroupName
//				String fPath = "root:"+ExperimentName+":imaging_data:"
//				String fWaveName = fPath+GroupName+"_im"+num2str(presentDimSize)
//				
//				Duplicate/O ww $fWaveName
//				
//				break
//				
//			default: 
//				break
//				
//			
//			
//		Endswitch
//						
						
		
		
		
		If(status!=0)
			SIDXCameraGetStatusText camera_handle,status,message
			TerminateAcquisition()
			//DeallocateCamera()
			printf "%s:%s","SIDXAcquisitionGetFrames",message
			return 0
		EndIf

		//SIDXAcquisitionStop camera_handle
		TerminateAcquisition()
		
		//NewImage $Wave_image
	EndIf
	
End

//////////////////// Main Loop that does collects "totalSweeps" number of sweeps /////////////////////////
/////////////////// This should be called from a background fxn (i.e. AcquirePhysSequence) ///////////
Function AcquireLoop()
	
///////////////// GLOBALS////////////////////////////////////////////////////////////////////	
	NVAR CurrentSweep=root:Globals:physiology:Run_globals:CurrentSweepNumber
	NVAR firstSweepTick = root:Globals:physiology:Run_globals:firstSweepTick
	NVAR sweepInterval=root:Globals:physiology:Run_globals:sweepInterval
	NVAR totalSweeps=root:Globals:physiology:Run_globals:totalSweeps
	NVAR saveMode = root:Globals:physiology:Run_globals:SaveMode
	
	SVAR ADCINs = root:Globals:physiology:DAC_ADC_globals:ADC_string_preBuffer
	SVAR SaveName = root:Globals:physiology:Run_globals:GroupName
	SVAR lastSavedGroup = root:Globals:physiology:Run_globals:lastSavedGroup
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
///////////////////////////////////////////////////////////////////////////////////////////////////		
	
	Variable V_AbortCode
	
	If(currentSweep>=totalSweeps) 	// collected all the sweeps... 
		CurrentSweep=0
		return 1		// ...kill the calling background function 
	EndIf
	
	try	// ... use this try so we can clean up (sweep #s, etc) if the user aborts. 
		
	If(CurrentSweep==0)	
		Execute "ITC18StimClear 0"	// Make sure things are hunky dory. Only do this on the first sweep cuz StimClear is quite slow.
		firstSweepTick=ticks
		
		If(SaveMode==1)
//			String grouplistWave_str = "root:"+ExperimentName + ":grouplist"
//			Wave/Z/T grouplist = $grouplistWave_str
//			
//				If(WaveExists(grouplist))
//					grouplist[dimsize(grouplist,0)-1] = SaveName
//					Redimension/N=(dimsize(grouplist,0)+1) grouplist
//				EndIf
//				
//			String path_phys = "root:"+ ExperimentName + ":physiology_data:"+SaveName
//				KillWavesByString(path_phys)
//			String path_img = "root:"+ExperimentName + ":imaging_data:" + SaveName
//				//KillWavesByMatch(
			
		EndIf
		
		AcquireOneSweep()
		
		SaveAndIncrement(ADCIns,SaveName,SaveMode) ////////////////////////////////////////////////////////
		
		CurrentSweep+=1
		
		return 0
	EndIf
	
	If(((ticks-firstSweepTick)>(SweepInterval*60)) && (CurrentSweep>0)) // VERSION 2: Count from beginning of previous sweep so only 
																	// the most recent sweep is affect if user changes sweep interval
	
	//Print "Collected Sweep " +num2str(CurrentSweep) +" in " + num2str((ticks-firstSweepTick)/60)+" seconds"
	
		firstSweepTick=ticks // Variable isn't really firstSweepTicks only... 
		
		If(CurrentSweep>=(totalSweeps-1)) // I should double check this to make sure it saves the proper sweeps..
			Print "Terminating and ending Background"
			AcquireOneSweep()	
			SaveAndIncrement(ADCIns,SaveName,SaveMode) ///////////////////////////////////////////////////////////////////////
			CurrentSweep=0
			EndOfSweepRoutines()
			return 1	// Kill the calling background
		EndIf
		
		AcquireOneSweep()
		SaveAndIncrement(ADCIns,SaveName,SaveMode) /////////////////////////////////////////////////////////////////////////////////
		CurrentSweep+=1
		return 0	
		
	EndIf	
	
	Variable pressed = GetKeyState(0)
		If(pressed==32)
			Print "Terminated by ESC"
			CurrentSweep=0
			EndOfSweepRoutines()
			return 1	// Continue with the background
		EndIf
		
	catch	// did user abort? 
		
		If(V_abortCode==1)
			CurrentSweep=0
			EndOfSweepRoutines()
			Print "TERMINATED by ABORT"
			return 1
			
		EndIf
		
	endtry
	
	
	return 0	
				
End

/// Make sure sweep length is not longer than sweep interval,etc....
/// Make sure Sweep length takes precedence over wave lengths... should be built into multiplx fxn. 




////////////////////// Have a generic "cleanup" function at the end that makes sure things were saved appropriately ///////////////

Function AcquirePhysSequence()

	///////////////// GLOBALS////////////////////////////////////////////////////////////////////	
	SVAR GroupName = root:Globals:physiology:Run_globals:GroupName
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	SVAR lastSavedGroup = root:Globals:physiology:Run_globals:lastSavedGroup
	NVAR saveMode = root:Globals:physiology:Run_globals:saveMode
	NVAR SweepLength = root:Globals:physiology:Run_globals:SweepLength
	NVAR SweepInterval = root:Globals:physiology:Run_globals:SweepInterval
	NVAR currentSweep = root:Globals:physiology:Run_globals:CurrentSweepNumber
		currentSweep=0
	NVAR AutoTrigger = root:Globals:physiology:Run_globals:AutoTrigger
	NVAR ImagingIsOn = root:Globals:physiology:Run_globals:ImagingIsOn
	NVAR TriggerChannel = root:Globals:physiology:Run_globals:TriggerChannel
	///////////////////////////////////////////////////////////////////////////////////////////////////	

	Variable newInterval
	

	String ExptFolder = "root:"+ExperimentName
	String grouplistWave_str = ExptFolder+":grouplist"
	
	If(!DataFolderExists(ExptFolder))
		DoAlert 0, "You need to set up the experiment first"
		return 0
	EndIf
	
	
	Wave/Z/T grouplist = $grouplistWave_str
	
Variable savePrompt
Variable index, groupExists
String thisString

Do
	 thisString = grouplist[index]
	If(strlen(thisString)==0)
		break
	EndIf		

	If(StringMatch(thisString,GroupName))		/////////////////////////////// Change this to a prompt ////////////////////
		groupExists=1
	EndIf
	
	Index+=1

While(index<dimsize(grouplist,0))

	
	If(groupExists&saveMode==1)
		DoAlert 1, "This group name already exists. Overwrite the previous group? \r YOU WILL LOSE DATA"
		If (V_flag==2)
			ControlInfo/W=Main STOP_tab0
				If(V_flag)
					Button STOP_tab0, win=Main,title="\\K(19456,39168,0)\\f01RUN ", rename=RUN_tab0
					return 0
				EndIf			
			return 0
		EndIf
	EndIf
	
	
	
	If(AutoTrigger & ImagingIsOn)
	Wave/Z trig_pulse
	Make/O/N=400 root:trig_pulse;trig_pulse[10,20]=1
		String CheckBoxName = "TTL"+num2str(TriggerChannel) + "_tab2"
		String popUpName = "TTLW" + num2str(TriggerChannel) + "_tab2"
		
		String CheckBoxProc = "TTL_Checklist_proc(\"" + CheckBoxName + "\"," + num2str(TriggerChannel) + ")"
	
		Execute CheckBoxProc
		ControlUpdate/W=Switchboard $CheckBoxName; Checkbox $CheckBoxName win=Switchboard, value=1
		
		
		String dfSav = GetDataFolder(1)
		
		SetDataFolder root:
		
		String AllOutwaves = Sortlist(WaveList("*_pulse",";",""),";",4)
		Variable popupMode = WhichListItem("trig_pulse",AllOutwaves)
		
		SetDataFolder dfSav
		
		String PopupProc = "TTL_popup_Proc(\"" + popUpName + "\",1" + ",\"trig_pulse\")"
		Execute PopupProc
		ControlUpdate/W=Switchboard $popUpName; PopupMenu  $popUpName win=Switchboard , mode = popUpMode+1	
		
	EndIf
	

	Execute "ITC18StimClear 0"	// Only on the first sweep... 


	KillBackground
	
	SetBackground AcquireLoop()
	
	If(SweepInterval==0)
		CtrlBackground period=1,start // "Fast mode"
	Else
		CtrlBackground period=10,start
	EndIf
	
End


// check that sweep length<sweep interval (make sure multiplex handles lengths w/ "precedence")




////////////////////////////////////////////////////////////////////////////////////

Function SaveAndIncrement(SaveString,WaveStem,increment)

	String SaveString
	String WaveStem
	Variable increment
	
	///////////////// GLOBALS////////////////////////////////////////////////////////////////////	
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	NVAR PresentDimSize = root:Globals:physiology:Run_globals:PresentDimSize
	NVAR CurrentSweepNumber = root:Globals:physiology:Run_Globals:CurrentSweepNumber
	///////////////////////////////////////////////////////////////////////////////////////////////////	

	If(increment==0 || (strlen(SaveString)==0))
		
		return 0
	EndIf
		
		
	String dfSav
	String ADCStem = "root:Globals:physiology:ADC_input_waves:"
	String tmpString=SaveString

	String fullPath = "root:" + ExperimentName+":physiology_data:" //////////////// will need the full path in the new folder aware context......
	
	
	Do
		If(Strlen(tmpString)==0)	// no channels left to save?
			break
		EndIf
		
		String thisADCnum=tmpString[strlen(tmpString)-1]	// grab the channel number...
		String thisADCWave = ADCStem + "ADC"+thisADCnum
		String SavedWave = fullPath+WaveStem+"_"+ thisADCnum
			
		tmpString=RemoveEnding(tmpString)	// ..keep popping off the last channel number till we're done saving everything 

		Wave/Z ThisADC=$thisADCWave	// grab the wave. 
	
		If(WaveExists($SavedWave) && currentSweepNumber>0)	// already saved? (i.e. more than 1 sweep in...)
			Wave ww = $SavedWave

			Redimension/N=(dimsize($thisADCWave,0),dimsize(ww,1)+1) ww	
			ww[0,*][dimsize(ww,1)]=ThisADC[p]		// add the most recent sweep to the saved wave
		
		Else	// didn't save yet ? (i.e. its the first sweep)
		
			Duplicate/O ThisADC $SavedWave		// Could be something problematic here.... 
			Redimension/N=(dimsize($SavedWave,0),1) $SavedWave
			
		EndIf
		
	While(1)

		PresentDimSize = dimsize($SavedWave,1)
End



Function ButtonProc_6(ba) : ButtonControl	// The experiment setup button.... 
	STRUCT WMButtonAction &ba
	SVAR ExperimentName = root:Globals:physiology:Run_Globals:ExperimentName
	SVAR WorkingFolder = root:Globals:imaging:ImageAnalysisGlobals:WorkingFolder
	
	String basePath = "root:"+ExperimentName
	String fullPath_phys = "root:"+ExperimentName+":physiology_data"
	String  fullPath_imag = "root:"+ExperimentName+":imaging_data"
	String dfSav = GetDataFolder(1)
	
	switch( ba.eventCode )
		case 2: // mouse up
		//Print fullPath_phys
		//Print fullPath_imag
		
			NewDataFolder $basePath
			NewDataFolder $fullPath_phys
			NewDataFolder $fullPath_imag
			
			SetDataFolder basePath		
				Make/O/T/N=(1,4)grouplist
			//SetDataFolder fullPath_image
				Make/O/T/N=(1,2) imageList
			SetDataFolder dfSav
			
			WorkingFolder = "root:"+ExperimentName
			
			break
	endswitch

	return 0
End

////////////////////////////////////////////////////////////////////////////////////////////////////////////
 /////////// Kill all waves w/ a certain channel name. ///////////////////////////////////
Function KillWavesByString(inStringName)
String inStringName
Variable ChanNum

	Do
		String thisWave = inStringName+"_"+num2str(ChanNum)
		Print thisWave
		
		If (WaveExists($thisWave))
			KillWaves/Z $thisWave
		EndIf
		
		chanNum+=1
	
	While(ChanNum<8)
	
End



Function KillWavesByMatch(inStringName,folderPath)
String inStringName // The wave name...
String folderPath // i.e. root:Globals: ... ...
Variable index

String dfSav = GetDataFolder(1)


	If(DataFolderExists(folderPath))
		SetDataFolder folderPath
	Else
		return 0
	EndIf

	String AllMatchedWaves = Wavelist(inStringName+"_im*",";","")
	Print AllMatchedWaves
	
	//String GreppedMatch = GrepList(AllMatchedWaves,"(?<!_)[A-Za-z0-9]_im[0-9]+$")
	//Print "GMATCH" + GreppedMatch
	
	Do
		String ThisWave = StringFromList(index,AllMatchedWaves)
		
		If(Strlen(ThisWave)==0)
			return 0
		EndIf
		
		If(WaveExists($ThisWave))
			KillWaves/Z $thisWave
		EndIf
		
		index+=1
	
	While(1)
	
	setDataFolder dfSav
End


Function StimMaker_QuickTab(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	variable index
	
	switch( ba.eventCode )
		case 2: // mouse up
				String ActiveWindows = WinList("StimMaker*",";","WIN:64")
				
					If(Strlen(ActiveWindows)==0)
						Execute "AcqMakeStimMaker()"
					Else
					
						Do
							String thisWin=StringFromList(index,ActiveWindows)
							
							If(Strlen(thisWin)==0)
								break
							EndIf
							
							Print thisWin
							KillWindow $thisWin
							
							index+=1
						
						While(1)				
					
					
					EndIf
						
				
			break
	endswitch

	return 0
End



	
/////////////////////////////// THE "MAIN" Panel ///////////////////////////////////////////////////////////

Function AcqMakeMainPanel()
	
	InitializeExperiment()
	
	DoWindow/F Main
	If(V_Flag==1)
		return 0
	EndIf
	
	NVAR TillLampPresent = root:Globals:Physiology:Run_Globals:TillLampPresent
	PauseUpdate; Silent 1		// building window...
	NewPanel /N=Main/W=(48,107,281,513) as "Main"
	SetDrawLayer UserBack
	SetDrawEnv linefgc= (65280,0,0),fillfgc= (60928,60928,60928)
	DrawRect 9,9,228,81
	SetDrawEnv fsize= 14
	DrawText 87,67,"current sweep:"
	SetDrawEnv linefgc= (65280,0,0),fillfgc= (60928,60928,60928)
	DrawRect 8,298,227,389
	SetVariable SweepName4,pos={14,19},size={212,20},title="Experiment Name"
	SetVariable SweepName4,fSize=15
	SetVariable SweepName4,limits={-inf,inf,0},value= root:Globals:physiology:Run_globals:ExperimentName
	SetVariable SweepName,pos={42,308},size={150,16},title="Group Name"
	SetVariable SweepName,limits={-inf,inf,0},value= root:Globals:physiology:Run_globals:GroupName
	TabControl tab0,pos={6,95},size={224,200},proc=TabProc
	TabControl tab0,tabLabel(0)="Physiology settings",tabLabel(1)="Imaging Settings"
	TabControl tab0,value= 0
	Button button0,pos={14,48},size={68,22},proc=ButtonProc_6,title="Set Up "
	SetVariable SweepName1,pos={42,328},size={150,16},title="Sweep Length (ms)"
	SetVariable SweepName1,limits={-inf,inf,0},value= root:Globals:physiology:Run_globals:SweepLength
	SetVariable totalSweeps,pos={42,369},size={150,16},title="Total Sweeps"
	SetVariable totalSweeps,limits={1,inf,0},value= root:Globals:physiology:Run_globals:totalSweeps
	SetVariable swpInterval,pos={42,348},size={150,16},title="Sweep Interval (s)"
	SetVariable swpInterval,limits={0,inf,0},value= root:Globals:physiology:Run_globals:sweepInterval
	Button InitCamera_tab1,pos={28,121},size={87,24},disable=1,proc=InitializeCamera_button,title="Intialize camera"
	Button closecamera_tab1,pos={122,121},size={87,24},disable=1,proc=CloseCamera_button,title="close camera"
	TitleBox CamParams_tab1,pos={24,155},size={100,21},disable=1,title="Camera Parameters"
	TitleBox CamParams_tab1,fSize=12,frame=2,fColor=(0,15872,65280)
	GroupBox groupbox_tab1,pos={18,184},size={195,47},disable=1
	GroupBox groupbox_tab1,labelBack=(52224,52224,52224),frame=0
	GroupBox groupbox_tab1,fColor=(52224,52224,52224)
	SetVariable Binx_tab1,pos={30,188},size={59,16},disable=1,title="Bin X"
	SetVariable Binx_tab1,limits={-inf,inf,0},value= root:Globals:imaging:CameraParameterGlobals:X_pixels,bodyWidth= 30
	SetVariable Biny_tab1,pos={30,207},size={59,16},disable=1,title="Bin Y"
	SetVariable Biny_tab1,limits={-inf,inf,0},value= root:Globals:imaging:CameraParameterGlobals:Y_pixels,bodyWidth= 30
	SetVariable Exposure_tab1,pos={106,187},size={97,16},disable=1,title="Exposure (s)"
	SetVariable Exposure_tab1,limits={-inf,inf,0},value= root:Globals:imaging:CameraParameterGlobals:exposure_time
	SetVariable Frames_tab1,pos={106,209},size={99,16},disable=1,title="Frames/movie"
	SetVariable Frames_tab1,limits={-inf,inf,0},value= root:Globals:imaging:CameraParameterGlobals:num_frames
	GroupBox groupbox2_tab1,pos={20,240},size={193,48},disable=1
	GroupBox groupbox2_tab1,labelBack=(34816,34816,34816),fColor=(52224,52224,52224)
	Button OneSweep_tab1,pos={28,245},size={87,18},disable=1,proc=CollectOneSweep_button,title="Collect 1 Sweep"
	Button OneSweep_tab1,labelBack=(34816,34816,34816),fSize=12
	Button focus_tab1,pos={122,245},size={87,20},disable=1,proc=Focus_button,title="focus"
	Button focus_tab1,help={"CTRL To Auto Focus, CTRL-SHIFT For 1 SD"}
	Button focus_tab1,labelBack=(34816,34816,34816),fSize=15
	ValDisplay CurrentSweep,pos={182,51},size={36,18},fSize=14
	ValDisplay CurrentSweep,limits={0,0,0},barmisc={0,1000},mode= 1
	ValDisplay CurrentSweep,value= #"root:Globals:Physiology:Run_globals:CurrentSweepNumber"
	Button RUN_tab0,pos={18,118},size={80,26},proc=KillButton,title="\\K(19456,39168,0)\\f01RUN "
	SetVariable Monochrome_wavelength_tab1,pos={66,269},size={110,16},disable=1,title="wavelength"
	SetVariable Monochrome_wavelength_tab1,limits={340,720,0},value= root:Globals:physiology:Run_globals:TillLamp_Lambda
	PopupMenu SaveMode_tab0,pos={108,121},size={109,21},title="Mode:"
	PopupMenu SaveMode_tab0,mode=1,bodyWidth= 74,popvalue="No Save",value= #"\"No Save; Save\"",proc=SaveModes_Pop
	GroupBox ImagTriggers_tab0,pos={17,212},size={122,39}
	GroupBox ImagTriggers_tab0,labelBack=(52224,52224,52224)
	CheckBox UserTrigger_tab0,pos={18,233},size={108,14},proc=TriggerCheckProc,title="I'll control triggering"
	CheckBox UserTrigger_tab0,value= 0,mode=1
	CheckBox AutoTrigger_tab0,pos={18,215},size={76,14},proc=TriggerCheckProc,title="Auto Trigger"
	CheckBox AutoTrigger_tab0,value= 1,mode=1
	GroupBox ImagTriggers1_tab0,pos={17,160},size={122,25}
	GroupBox ImagTriggers1_tab0,labelBack=(52224,52224,52224)
	CheckBox CollectImages_tab0,pos={20,165},size={93,14},title="Collect Images?"
	CheckBox CollectImages_tab0,variable= root:Globals:physiology:Run_globals:ImagingIsOn
	GroupBox ImagTriggers3_tab0,pos={145,159},size={79,127}
	GroupBox ImagTriggers3_tab0,labelBack=(52224,52224,52224)
	Button DataViewer_tab0,pos={151,165},size={67,35},title="Data \rViewer"
	Button OLM_tab0,pos={151,205},size={67,35},title="Online\rMeasures"
	Button StimMaker_tab0,pos={151,245},size={67,35},proc=StimMaker_QuickTab,title="Make \rStimuli"
	GroupBox ImagTriggers2_tab0,pos={17,256},size={122,25}
	GroupBox ImagTriggers2_tab0,labelBack=(52224,52224,52224)
	SetVariable SampInterval_tab0,pos={96,261},size={36,16},title=" "
	SetVariable SampInterval_tab0,limits={-inf,inf,0},value= root:Globals:physiology:Run_globals:SamplingInterval
	TitleBox Delta_ITC_tab0,pos={24,261},size={61,15},title="\\F'Symbol'D\\F'Arial't ITC (ms)"
	TitleBox Delta_ITC_tab0,fSize=12,frame=0
	TitleBox Camera_tab0,pos={19,188},size={44,21},title="Camera"
	TitleBox Camera_tab0,fColor=(0,15872,65280)
	
	TriggerCheckProc("AutoTrigger_tab0",0)
	
	Variable V_disable
	If(tillLampPresent)
			V_disable=0
		Else
			V_disable=1
		EndIf
		
		ModifyControl/Z Monochrome_wavelength, disable=V_disable

End

Function SaveMode_pop(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	NVAR/Z SaveMode = root:Globals:physiology:Run_globals:SaveMode
	
	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			SaveMode = popNum-1
			
			break
	endswitch

	return 0
End


Function KillButton(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
	String ExperimentFolder = "root:" + ExperimentName + ":physiology_data:"
	NVAR PresentDimSize = root:Globals:physiology:Run_globals:PresentDimSize
	
	switch( ba.eventCode )
		case 2: // mouse up
			If (cmpstr(ba.ctrlName, "RUN_tab0") == 0)
				If(DataFolderExists(ExperimentFolder))
					Button $ba.ctrlName, title= "\\K(65280,0,0)\\f01STOP", rename=STOP_tab0
					PresentDimSize=0
					//Print "PDS:::" + num2str(PresentDimSize)
					//Print "KillButtonTest"
					AcquirePhysSequence()
				Else
					DoAlert 0, " You need to set up the experiment first" 
				EndIf
			Else
				Button $ba.ctrlName, title= "\\K(19456,39168,0)\\f01RUN ", rename=RUN_tab0
				KillBackground
				TerminateAcquisition()
				EndOfSweepRoutines()
				PresentDimSize=0
			EndIf
		
			break
	endswitch

	return 0
End

//// For documentation of total num sweeps, etc.... /// 

Function EndOfSweepRoutines()
SVAR ExperimentName = root:Globals:physiology:Run_globals:ExperimentName
SVAR GroupName = root:Globals:physiology:Run_globals:GroupName
NVAR PresentDimSize = root:Globals:physiology:Run_globals:PresentDimSize
NVAR ImagingIsOn = root:Globals:physiology:Run_globals:ImagingIsOn

NVAR SweepLength = root:Globals:physiology:Run_globals:SweepLength
NVAR SweepInterval = root:Globals:physiology:Run_globals:SweepInterval
NVAR ImagingIsOn = root:Globals:physiology:Run_globals:ImagingIsOn

NVAR saveMode = root:Globals:physiology:Run_globals:SaveMode


Wave/T Grouplist = $"root:"+ExperimentName+":grouplist"

	If(SaveMode==1)
	
		RemoveFromWavelist(Grouplist,GroupName)
		
		Grouplist[dimsize(Grouplist,0)][0] = GroupName

		If(ImagingIsOn)
			Grouplist[dimsize(Grouplist,0)][1]="has Images"
		EndIf


		Grouplist[dimsize(Grouplist,0)][2] = "TotalSweeps:"+num2str(PresentDimSize)+";SweepLength:"+num2str(SweepLength)+";SweepInterval:"+num2str(SweepInterval)+";last sweep collected at:"+time()
		Redimension/N=(dimsize(Grouplist,0)+1,3) Grouplist

	EndIf
	

	ControlInfo/W=Main STOP_tab0
		If(V_flag)
			Button STOP_tab0, win=Main,title="\\K(19456,39168,0)\\f01RUN ", rename=RUN_tab0
			return 0
			
		EndIf
		
	
						
End


Function TriggerCheckProc(name,value):CheckBoxControl
	String name
	Variable value
	
	NVAR gRadioVal_triggering= root:Globals:Physiology:Run_globals:gRadioVal_triggering
	NVAR AutoTrigger = root:Globals:Physiology:Run_globals:AutoTrigger
	
	Strswitch(name)
		case "AutoTrigger_tab0":
			gRadioVal_triggering= 1
			AutoTrigger=1
			
			break
		
		case "UserTrigger_tab0":
			gRadioVal_triggering= 2 
			AutoTrigger=0
						
			break
		
	endswitch
	
	CheckBox AutoTrigger_tab0,Win=Main,value=gRadioVal_triggering==1
	CheckBox UserTrigger_tab0,Win=Main,value=gRadioVal_triggering==2
	
End

Function TabProc(ctrlName,tabNum) : TabControl
String ctrlName
Variable tabNum
String curTabMatch= "*_tab"+num2istr(tabNum)
String controls= ControlNameList("")
Variable i, n= ItemsInList(controls)
	For(i=0; i<n; i+=1)
		String control= StringFromList(i, controls)
		//Print control
		Variable isInATab= stringmatch(control,"*_tab*")
			If( isInATab )
				Variable show= stringmatch(control,curTabMatch)
				ControlInfo $control // gets V_disable
				If( show )
					V_disable= V_disable & ~0x1 // clear the hide bit
				Else
					V_disable= V_disable | 0x1 // set the hide bit
		      		Endif
					ModifyControl $control disable=V_disable
			Endif
	Endfor

	return 0
End

Function SaveModes_Pop(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	NVAR/Z SaveMode = root:Globals:physiology:Run_globals:SaveMode
	Variable SaveMode_pop=pa.popNum
	
	
	switch( pa.eventCode )
		case 2: // mouse up
				If(!NVAR_Exists(SaveMode))
					return 0
				Else
					SaveMode = 	SaveMode_pop-1
					//Print num2str(SaveMode)
				EndIf
				
			break
	endswitch

	return 0
End


Function RemoveFromWavelist(WvName,GroupName)
Wave/T WvName
String GroupName

If(!WaveExists(WvName))
	return 0
EndIf

Variable numCol
Wave/T ww = $WvName
String WaveString


Do
	String txtEntry = WvName[numCol]
	//Print txtEntry
	If(StringMatch(txtEntry,GroupName))
		//Print "RemoveWavelist"
		DeletePoints/M=0 numCol,1,WvName
		break
	EndIf
	
	numCol+=1
	
While(numCol<dimsize(WvName,0))


End
